﻿namespace EInk.Dtos
{
    public enum CodeEnum
    {
        Ok = 0,
        Fail = 1,
        Error = 500
    }

    public class ResultDto
    {
        public CodeEnum Code { get; set; }
        public string? Message { get; set; }

        //public long? Time { get; set; }

        public static ResultDto Success()
        {
            return new ResultDto { Code = CodeEnum.Ok, Message = "Ok!" };
        }

        //public static ResultDto Success(long time)
        //{
        //    return new ResultDto { Code = CodeEnum.Ok, Message = "Ok!", Time = time };
        //}

        public static ResultDto Fail(string message)
        {
            return new ResultDto { Code = CodeEnum.Fail, Message = message};
        }

        public static ResultDto Error(string message)
        {
            return new ResultDto { Code = CodeEnum.Error, Message = message };
        }
    }

    public class ResultDto<T> : ResultDto where T : class
    {
        public T? Data { get; set; }

        public static new ResultDto<T> Success()
        {
            return new ResultDto<T> { Code = CodeEnum.Ok, Message = "Ok!" };
        }

        public static new ResultDto Fail(string message)
        {
            return new ResultDto { Code = CodeEnum.Fail, Message = message };
        }

        public static ResultDto<T> Success(T data)
        {
            return new ResultDto<T> { Code = CodeEnum.Ok, Message = "Ok!", Data = data };
        }

        //public static ResultDto Success(long time, T data)
        //{
        //    return new ResultDto<T> { Code = CodeEnum.Ok, Message = "Ok!", Time = time, Data = data };
        //}
    }
}
